#include <stdio.h>
#include <fcntl.h>
#define sqr(x) (x*x)
int maxrow;         /* maxrow, maxcol ARE USER entered  */
int maxcol;         /*   VALUES LATER IN PROGRAM - main */
int xoff;           /* x offset to center image on screen */
int yoff;           /* y offset to center image on screen */
int MAXCOL = 639;        /* set up for EGA */
int MAXROW = 349;        /* MAXCOL, MAXROW -1 of resolution */
int max_colors = 8;       /* MAXCOL, MAXROW, EGAMODE, max_colors */
int egacolor[8] = {0,1,9,11,10,14,12,4};
int egabw[2] = {0,15};
int colorval[120];
int EGAMODE = 16;       /*     are ALL INTERRELATED - see below */
 /*   EGA  Text/  Adapter   Colors    Resolution
     Mode  Graph
       0     T      C         16      320 X 200
       1     T      K        16/64    320 X 350
       2     T      C         16      640 X 200
       3     T      K        16/64    640 X 350
       4,5   G     C,K         4      320 X 200
       6     G     C,K         2      640 X 200
       7     T      M          4      720 X 350
       13    G     C,K        16      320 x 200
       14    G     C,K        16      640 X 200
       15    G     C,K         4      640 X 350
       16    G     C,K       16/64    640 X 350  */
int max_iterations;     /* 1000 for best results: 100 OK */
int max_size = 4;          /* usually 4 */
float xmax, xmin, ymax, ymin, p,q;
int colint;
char coltype;
char fn[50], savescr, settype;

void mandel (float Pmax, float Pmin, float Qmax, float Qmin)
{
  int color, row, col;
  float P, Q, modulus, deltaP, deltaQ,
        Xcur, Xlast, Ycur, Ylast;
  deltaP = (Pmax - Pmin)/maxcol; /* determine real axis increment */
  deltaQ = (Qmax - Qmin)/maxrow; /* determine imaginary axis increment */
  for (col = 0; col <= maxcol; col++)  /* look at each point on screen */
   for (row = 0; row <= maxrow; row++)
   {
    P = Pmin + col * deltaP;    /* determine coordinates of point in C plane */
    Q = Qmax - row * deltaQ;
    Xlast = Ylast = modulus = 0.0;
    color = 0;
    while ((modulus < max_size) && (color < max_iterations))
    {  /* go around until function blows up or until max_iterations */
     Xcur = sqr (Xlast) - sqr (Ylast) + P; /* find components of next Z */
     Ycur = 2 * Xlast * Ylast + Q;
     color++;
     Xlast = Xcur;
     Ylast = Ycur;
     modulus = sqr (Xcur) + sqr (Ycur);
    }
   drawpoint (xoff + col, yoff + row, colorval[color]);
   if (kbhit())
	  {
	  savescr = 'n';
	  return;
	  }
  }
} /* mandel */

void julia (float Xmax, float Xmin, float Ymax, float Ymin, float P, float Q)
{
  int color, row, col;
  float modulus, deltaX, deltaY,
        Xcur, Xlast, Ycur, Ylast;
  deltaX = (Xmax - Xmin)/maxcol; /* determine real axis increment */
  deltaY = (Ymax - Ymin)/maxrow; /*  imaginary axis increment */
  for (col = 0; col <= maxcol; col++) /* look at each point on screen */
    for (row = 0; row <= maxrow; row++)
    {
     modulus = 0.0;
     color = 0;
     Xlast = Xmin + col * deltaX; /* find coordinates of Z (0) */
     Ylast = Ymax - row * deltaY;
    while ((modulus < max_size) && (color < max_iterations))
     {   /* go around until function blows up or until max_iterations */
      Xcur = sqr (Xlast) - sqr (Ylast) + P;  /* find components of next Z */
      Ycur = 2 * Xlast * Ylast + Q;
      color++;
      Xlast = Xcur;
      Ylast = Ycur;
      modulus = sqr (Xcur) + sqr (Ycur);
     }
    drawpoint (xoff + col, yoff + row, colorval[color]);
    if (kbhit())
	   {
		 savescr = 'n';
		 return;
		 }
    }
}  /* julia */

#include <stdio.h>
#include <dos.h>
#define TRUE -1
#define ENABLE 0x0F
#define INDEXREG 0x3CE
#define VALREG 0x3CF
#define OUTINDEX(index,val) {outp(INDEXREG, index); outp(VALREG, val);}
#define EGA_BASE 0xA0000000L
#define WIDTH 80L
#define XMIN 0
#define YMIN  0
#define XORIT 0x80
drawpoint(x, y, color)
int x, y, color;
{
 unsigned char mask = 0x80;

 char far *base;

 if (x < XMIN || x > MAXCOL
     || y < YMIN || y > MAXROW) return;

 base = (char far *) (EGA_BASE +
       ((long)y * WIDTH + ((long)x /
       8L)));

 mask >>= x % 8;

 OUTINDEX(0, color);
 OUTINDEX(1, ENABLE);
 OUTINDEX(8, mask);
 OUTINDEX(3, 0x18);
 *base &= TRUE;
 }

reset_EGA()
{
 OUTINDEX(0, 0);
 OUTINDEX(1, 0);
 OUTINDEX(8,TRUE);
 OUTINDEX(3,0);
}

void set_mode(int mode)
{
   union REGS r;
   r.h.al = mode;
   r.h.ah = 0;
   int86(0x10, &r,&r);
}

int c_break(void)
{
 printf("Program aborted: terminating\n");
 return(0);
 }

void gridpnt()
{
 int i,j;
 for(i=12; i < 639; i+=13)
   for(j=9; j < 349; j+=10)
      drawpoint(i,j,15);
}

void gridline()
{
 int i,j;
 for(i=63; i < 639; i+=64)
   for(j=0; j<=349; j++)drawpoint(i,j,15);
 for(j=34; j < 349; j+=35)
   for(i=0; i <= 639; i++)
      drawpoint(i,j,15);
}

#define ININDEX(index,value) {outp(0x3C4,index); outp(0x3C5,value);}
char buffer[1024];
void screensave()
{
 FILE *fpar, *fcreat(), *fopen();
 char far *base;
 char *pointer;
 int fp,color;
 int i,j,k;
 long fpos;
 k=0;
 for(k=0; (k<20) && (fn[k] != '\0'); k++);
 fn[k] = '.';
 fn[k+1] = 'M';
 fn[k+2] = 'D';
 fn[k+3] = 'L';
 fn[k+4] = '\0';
 if((fp = creat(fn,0777 | O_BINARY)) == -1)
   if((fp = open(fn,1 | O_BINARY)) == -1)
     { printf("Cannot open file for writing screen"); exit(1);}
 for(color=0; color < 4; color++)
   {
    base = (char far *) 0xA0000000L;
    OUTINDEX(5, 0);
    OUTINDEX(4, color);
    for(i=0; i < 32; i++)
      {
       pointer = buffer;
       for(j=0; j < 1024; j++)
          *(pointer++) = *(base++);
       if(_write(fp,buffer,1024) == -1)
         { printf("Error writing screen to file"); exit(1);}
       }
   }
 _close(fp);
 fn[k++] = '.';
 fn[k++] = 'm';
 fn[k++] = 'd';
 fn[k++] = 'p';
 fn[k++] = '\0';
 if ((fpar=fopen(fn,"w"))== NULL)
     {printf("\nError opening coordinate file"); return;}
 if(settype=='m')
   p=q=0.0;
 fprintf (fpar,"%c %f %f %f %f %f %f ",settype,xmax,xmin,ymax,ymin,p,q);
 fclose (fpar);
}

void set_palette(int color, int palette)
{
 union REGS r;
 r.h.ah = 0x10;
 r.h.al = 0;
 r.h.bl = color;
 r.h.bh = palette;
 int86(0x10, &r, &r);
 }

float getfp(FILE *fp)
{
 float res;
 long fst,i,lst,k;
 int fpchar, chsign;
 fst = i = lst = 0;
 chsign = 1;
 fpchar = getc(fp);
 if (fpchar == '-')
   {
    chsign = -1;
    fpchar = getc(fp);
    }
 if (fpchar == '+')
   fpchar = getc(fp);
 while((fpchar >= '0') && (fpchar <= '9'))
    {
     fst = fst * 10 + (fpchar - '0');
     fpchar = getc(fp);
     }
 if (fpchar == '.')
   {
    fpchar = getc(fp);
    while ((fpchar >= '0') && (fpchar <= '9'))
    {
     i++;
     lst = lst * 10 + (fpchar - '0');
     fpchar = getc(fp);
     }
 }
 res = lst;
 for(k=0; k < i; k++) res = res / 10.0;
 return((float)chsign * (fst + res));
}

int getint()
{
 int num;
 char digit;
 num = 0;
 while(((digit=getch()) >= '0') && (digit <= '9'))
	 num = num * 10 + (digit - '0');
 return(num);
 }

int getpint()
{
 int num;
 char digit;
 num = 0;
 while(((digit=getch()) >= '0') && (digit <= '9'))
   {
    putch(digit);
	 num = num * 10 + (digit - '0');
	 }
 return(num);
 }

void readscr()
{
 FILE *fpar, *fcreat(), *fopen();
 char far *base;
 char reply, *pointer;
 unsigned int i,j,k;
 int fp, color;
 printf("\nEnter filename: ");
 scanf("%s",fn);
 for (k=0; (k<20) && (fn[k] != '\0'); k++);
 while(1) /* DO FOREVER ....... */
  {
   printf("\nScreen (s), coordinates(c) or return(r) <s>:");
   switch(getch())
   {
    case 'c':
      printf("COORDINATES");
      fn[k] = '.';
      fn[k+1] = 'M';
      fn[k+2] = 'D';
      fn[k+3] = 'P';
      fn[k+4] = '\0';
      if((fpar = fopen(fn,"r")) == NULL)
        {printf("\nERROR: Cannot open coordinate file to read"); break; }
      settype = getc(fpar);
      getc(fpar);
      xmax = getfp(fpar);
      xmin = getfp(fpar);
      ymax = getfp(fpar);
      ymin = getfp(fpar);
      if (settype != 'j')
        printf("\nMANDELBROT Set: P = (%f,%f) Q = (%f,%f)",
                                     xmin, xmax, ymin, ymax);
       else
        {
         p = getfp(fpar);
         q = getfp(fpar);
         printf("\nJULIA Set: X=(%f,%f) Y=(%f,%f) \n           P=%f Q=%f",
                                     xmax, xmin, ymax, ymin, p, q);
         }
      break;
    default:
      printf("SCREEN");
      fn[k] = '.';
      fn[k+1] = 'M';
      fn[k+2] = 'D';
      fn[k+3] = 'L';
      fn[k+4] = '\0';
      if((fp = open(fn,O_BINARY)) == -1)
        {printf("\nERROR: Cannot open screen file to read"); return; }
      set_mode(EGAMODE);
      for(color=0; color < 4; color++)
       {
        ININDEX(2, 1 << color);
        base = (char far *) 0xA0000000L;
        for(i=0; i < 32; i++)
          {
           read(fp, buffer, 1024);
           pointer = buffer;
           for (j=0; j < 1024; j++)
              *(base++) = *(pointer++);
           }
        }
      close(fp);
      while ((reply=getch()) != ' ')
        switch(reply)
          {
           case 'G':
              gridpnt();
              break;

           case 'g':
              gridline();
              break;

           case 'p':
              i = getint();
				  j = getint();
				  set_palette(i,j);
              break;

         default:
				 if(reply == '\r') return;
             break;
          }
      set_mode(3);
      break;

    case 'r':
      printf("RETURN");
      return;
    }
  }
}

main()
{
 int i, mod;
 char reply;
 ctrlbrk(c_break);
 printf("MANDEL 5R3 : Mandelbrot and Julia Set Generator");
 while (1)  /* Do Forever ............... */
   {
    printf("\nGenerate Sets (g), Display saved sets (d) or Stop (s) <g>: ");
    while((reply = getch()) == 'd')
      {
       printf("DISPLAY");
       readscr();
       printf("\nGenerate Sets (g), Display saved sets (d) or Stop (s) <g>: ");
       }
   if(reply == 's')
    {
     printf("STOP");
     return;
     }
   printf("GENERATE");
   printf("\nRequired resolution (pixels): MxN: ");
   maxcol = 640;
   maxrow = 350;
   scanf("%dx%d",&maxcol, &maxrow);
   fflush(stdin);
   maxcol = maxcol - 1;
   maxrow = maxrow - 1;
   if(maxcol < 10 || maxcol > 639) maxcol = 639;
   if(maxrow < 10 || maxrow > 349) maxrow = 349;
   printf("Resolution: %d X %d pixels", maxcol+1, maxrow+1);
   xoff = (639 - maxcol) / 2;
   yoff = (349 - maxrow) / 2;
   printf("\nColoring: proportional (p), mod color (m) or mod B&W (b) <m>:");
   max_iterations = 100;
   switch (coltype = getch())
     {
      case 'p':
        printf("PROPORTIONAL");
        max_iterations = max_iterations / (max_colors - 1) * (max_colors-1);
        colint = max_iterations / (max_colors -1);
        for (i = 0; i < max_iterations; i++)
           colorval[i] = egacolor[max_colors - 1 - i / colint];
        break;

      default:
        coltype = 'm';
        printf("MOD COLOR\nEnter mod interval <1>:");
        if ((mod = getpint()) == 0) mod = 1;
        max_iterations = max_iterations/(mod*max_colors) * max_colors * mod;
        for (i = 0; i < max_iterations; i++)
           colorval[i] = egacolor[(i/mod) % max_colors];
        break;

      case 'b':
        printf("MOD B & W\nEnter mod interval <1>:");
        if ((mod = getpint()) == 0) mod = 1;
        max_iterations = max_iterations/(mod * 2) * mod * 2;
        for (i = 0; i < max_iterations; i++)
           colorval[i] = egabw[(i / mod) % 2];
        break;
      }
   printf("\nMandelbrot (m) or Julia (j) set <m>:");
   reply='y';
   switch(settype = getch())
    {
    default:
     settype = 'm';
     printf("MANDELBROT Set");
     printf("\nEnter real range - minimum: ");
     scanf("%f", &xmin);
     printf("                   maximum: ");
     scanf("%f", &xmax);
     printf("Enter imaginary range - minimum: ");
     scanf("%f", &ymin);
     printf("                        maximum: ");
     scanf("%f", &ymax);
     printf("\nSave screen after generation ? (y)es/(n)o <n>: ");
     if ((savescr = getch()) == 'y')
      {
       printf("YES\nEnter set name: ");
       scanf("%s",fn);
       }
      else printf("NO");
     printf("\nContinue processing: (y)es/(n)o? <y>: ");
     if ((reply = getch()) != 'n')
      {
       set_mode(EGAMODE);
       mandel(xmax, xmin, ymax, ymin);
		 reply = 'y';
       }
      else
		 printf("NO\nHit spacebar to continue");
	  break;  /* end CASE default */

   case 'j':
    printf("JULIA Set");
    printf("\nEnter range for x - minimum: ");
    scanf("%f", &xmin);
    printf("                    maximum: ");
    scanf("%f", &xmax);
    printf("Enter range for y - minimum: ");
    scanf("%f", &ymin);
    printf("                    maximum: ");
    scanf("%f", &ymax);
    printf("\nEnter real value: ");
    scanf("%f", &p);
    printf(" i maginary value: ");
    scanf("%f", &q);
    printf("Save screen after generation ? (y)es/(n)o <n>: ");
    if ((savescr = getch()) == 'y')
      { printf("YES\nEnter set name: ");
        scanf("%s",fn);
        }
      else printf("NO");
    printf("\nContinue processing: (y)es/(n)o <y>: ");
    if ((reply = getch()) != 'n')
     {
      set_mode(EGAMODE);
      julia (xmax, xmin, ymax, ymin, p,q);
		reply = 'y';
      }
    else
		printf("NO\nHit spacebar to continue");
	break;    /* end CASE 'j' */
      }  /* end SWITCH statement */
 if ((reply == 'y') && (savescr == 'y'))
        screensave();
 while((reply = getch()) != ' ')
   switch (reply)
     {
      case 's':
        i=0;
        while((fn[i++] = getch()) != '\r');
        fn[i-1]='\0';
        screensave();
        break;
      case 'G':
        gridpnt();
        break;
      case 'g':
        gridline();
        break;
      default:
         break;
      }
    reset_EGA();
    set_mode(3);
 } /* end while(Forever . . . . */
}
